<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_PackageStay ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_PackageStay extends AbstractStructArrayBase
{
    /**
     * The Stay
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_PackageStay[]
     */
    public $Stay;
    /**
     * Constructor method for ArrayOfJP_PackageStay
     * @uses ArrayOfJP_PackageStay::setStay()
     * @param \StructType\JP_PackageStay[] $stay
     */
    public function __construct(array $stay = array())
    {
        $this
            ->setStay($stay);
    }
    /**
     * Get Stay value
     * @return \StructType\JP_PackageStay[]|null
     */
    public function getStay()
    {
        return $this->Stay;
    }
    /**
     * This method is responsible for validating the values passed to the setStay method
     * This method is willingly generated in order to preserve the one-line inline validation within the setStay method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateStayForArrayConstraintsFromSetStay(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_PackageStayStayItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_PackageStayStayItem instanceof \StructType\JP_PackageStay) {
                $invalidValues[] = is_object($arrayOfJP_PackageStayStayItem) ? get_class($arrayOfJP_PackageStayStayItem) : sprintf('%s(%s)', gettype($arrayOfJP_PackageStayStayItem), var_export($arrayOfJP_PackageStayStayItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Stay property can only contain items of type \StructType\JP_PackageStay, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Stay value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_PackageStay[] $stay
     * @return \ArrayType\ArrayOfJP_PackageStay
     */
    public function setStay(array $stay = array())
    {
        // validation for constraint: array
        if ('' !== ($stayArrayErrorMessage = self::validateStayForArrayConstraintsFromSetStay($stay))) {
            throw new \InvalidArgumentException($stayArrayErrorMessage, __LINE__);
        }
        $this->Stay = $stay;
        return $this;
    }
    /**
     * Add item to Stay value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_PackageStay $item
     * @return \ArrayType\ArrayOfJP_PackageStay
     */
    public function addToStay(\StructType\JP_PackageStay $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_PackageStay) {
            throw new \InvalidArgumentException(sprintf('The Stay property can only contain items of type \StructType\JP_PackageStay, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Stay[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_PackageStay|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_PackageStay|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_PackageStay|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_PackageStay|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_PackageStay|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Stay
     */
    public function getAttributeName()
    {
        return 'Stay';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJP_PackageStay
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
